@extends('layouts.app', ['title' => __('User Management')])

@section('content')
    @include('layouts.headers.cards')

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('Inventaires') }}</h3>
                            </div>
                            {{--<div class="col-4 text-right">--}}
                                {{--<a href="{{ route('createItem') }}" class="btn btn-sm btn-primary">{{ __('Ajouter un produit') }}</a>--}}
                            {{--</div>--}}
                        </div>
                    </div>
                        @if($Success=Session::get('info'))
                            <div class="alert alert-success">{{$Success}}</div>
                        @endif
                    <div class="col-12">
                        @if (session('status'))
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                {{ session('status') }}
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        @endif
                    </div>
                    <div style="margin-left: 25px">
                        <span style="display: inline-block">
                            <div style="background: lightpink; border: none; width: 20px; height: 10px"></div>
                        </span>
                        <span style="display: inline-block; font-size: 14px">
                             <div>Alerte d'approvisionnement</div>
                        </span><br><br>
                    </div>


                    <div class="table-responsive" style="padding:10px">
                        <table id="example1" class="table table-bordered table-striped">
                            <thead class="thead-light">
                            <tr>
                                <th scope="col">{{ __('Image') }}</th>
                                <th scope="col">{{ __('Nom') }}</th>
                                <th scope="col">{{ __('Categorie') }}</th>
                                <th scope="col">{{ __('Restant') }}</th>
                                <th scope="col">{{ __('Entrées') }}</th>
                                <th scope="col">{{ __('Vente') }}</th>
                                <th scope="col">{{ __('Pertes') }}</th>
                                <th scope="col">{{ __('Final') }}</th>
                                @if(auth()->user()->isAdmin())
                                    <th scope="col">{{ __('Opération') }}</th>
                                @endif
                            </tr>
                            </thead>
                            <tbody>
                            @foreach ($items as $i=>$item)
                                <tr @if($item->remaining_quantity <= $item->threshold) style="background: lightpink; height: 80px" @endif style="height: 80px">
                                    <td>
                                        @if($item->image)
                                            <a href="{{ url('uploads/items/'.$item->image) }}" target="_blank"><img src="{{ url('uploads/items/'.$item->image) }}" alt="" style="width: 60px; height: 60px; object-fit: cover; border-radius: 5px"/></a>
                                        @endif
                                    </td>
                                    <td>{{ $item->name }}</td>
                                    <td>
                                        @php
                                          $Category=\App\Models\Category::find($item->category_id);
                                        @endphp
                                        @if($Category)
                                            {{$Category->name}}
                                            @else
                                        Néant
                                        @endif
                                    </td>
                                    <td>{{ $item->remaining_quantity }}</td>
                                    <td>{{ $item->entries }}</td>
                                    <td>{{ $item->sales }}</td>
                                    <td>{{ $item->losses }} </td>
                                    <td>{{ $item->finals }}</td>
                                    @if(auth()->user()->isAdmin())
                                        <td>
                                            <!--<a href="{{ route('editinventory',Crypt::encrypt($item->id))}}"><i class="fas fa-retweet"></i></a> -->
                                        <a type="button" class="btn btn-success btn-sm" data-toggle="modal" data-target="#exampleModal{{$i}}">Ravitailler</a>
                                        </td>
                                    @endif
                                    <div class="modal fade" id="exampleModal{{$i}}" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header" style="background-color: #1b4b72;">
                                                    <h5 class="modal-title" id="exampleModalLabel" style="color:white;">Ravitaillement de {{ $item->name }}</h5>
                                                </div>
                                                <div class="modal-body">
                                                    <form method="post" action="{{route('ravitailler',Crypt::encrypt($item->id))}}">
                                                        @csrf
                                                        <label>Quantité à ravitailler</label>
                                                        <input type="number" min="1" class="form-control input-sm" name="quantity" required><br>
                                                        <label>Fournisseur</label>
                                                        <select class="form-control" name="idSupplie" required>
                                                             <option value="">Cliquez</option>
                                                              @php
                                                                 $Supplie=\App\Models\Supplier::OrderBy('name')->get();
                                                              @endphp
                                                               @foreach($Supplie as $s)
                                                                <option value="{{$s->id}}">{{$s->name}}</option>
                                                               @endforeach
                                                        </select><br>
                                                        <input value="Valider" class="btn btn-outline-primary btn-sm" type="submit">
                                                        <button type="button" class="btn btn-outline-warning btn-sm" data-dismiss="modal">Fermer</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer py-4">
                        <nav class="d-flex justify-content-end" aria-label="...">
                            {{--                            {{ $users->links() }}--}}
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection