@extends('layouts.app', ['title' => __('User Management')])

@section('content')
    @include('users.partials.header', ['title' => __('Vente')])

    <div class="container mt--7">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card bg-secondary shadow">
                    <div class="card-header bg-white border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('Enregistrer une vente') }}</h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('sale') }}" class="btn btn-sm btn-primary">{{ __('Retourner à la liste') }}</a>
                            </div>
                        </div>
                    </div>
                  <div class="container">
                      @if($Success=Session::get('success'))
                          <div class="alert alert-success">{{$Success}}</div>
                      @endif
                      <div class="row">
                          <div class="col-md-5">
                              <div class="card-body">
                                  <form method="post" action="{{route('AddSale')}}" autocomplete="off">
                                      @csrf
                                      <h6 class="heading-small text-muted mb-4">{{ __('Informations sur la vente') }}</h6>
                                      <div class="pl-lg-4">
                                          @if($errors->any())
                                              <div class="msg">
                                                  <p>
                                                      <i class="fas fa-check"></i> {{$errors->first()}}
                                                  </p>
                                              </div>
                                          @endif
                                          <div class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
                                              <label class="form-control-label" for="input-name">{{ __('Client') }}</label><br>
                                              <input name="customer_id" type="hidden" class="form-control" value="{{$customers->id}}">
                                              <input type="text" class="form-control" value="{{$customers->name}}" readonly>
                                          </div>
                                          <div class="row">
                                              <div class="col-md-8">
                                                  <label class="form-control-label" for="input-name">{{ __('Produit') }}</label><br>
                                                  <select name="item_id" class="form-control form-control-alternative{{ $errors->has('name') ? ' is-invalid' : '' }}"  id="">
                                                      @foreach($items as $item)
                                                          <option value="{{ $item->id }}">{{ $item->name }} -
                                                              @php
                                                                  $Categori=\App\Models\Category::find($item->category_id);
                                                              @endphp
                                                              @if($Categori)
                                                                  {{$Categori->name}}
                                                              @else
                                                                  Catégorie inconnu
                                                              @endif

                                                          </option>
                                                      @endforeach
                                                  </select>
                                              </div>
                                              <div class="col-md-4">
                                                  <label class="form-control-label" for="input-name">{{ __('Quantité') }}</label>
                                                  <input min="1" type="number" class="form-control form-control-alternative" name="quantity" required>
                                              </div>
                                          </div>

                                          <!-- <button class="btn btn-primary" id="btn-command" type="button">Ajouter un produit <i class="ni ni-fat-add" style="font-size: 1em"></i></button>-->
                                          <br>
                                          <div class="text-center">
                                              <button type="submit" class="btn btn-success mt-4">{{ __('Enregistrer') }}</button>
                                          </div>
                                      </div>
                                  </form>
                              </div>
                          </div>
                          <div class="col-md-7">
                              <button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#exampleModal">
                                 Finaliser la commande
                              </button>
                              <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                  <div class="modal-dialog" role="document">
                                      <div class="modal-content">
                                          <div class="modal-body">
                                              <form method="post" action="{{route('printt')}}">
                                                  @csrf
                                                  <label>Voulez-vous finalisez la commande ? </label>
                                                  <input type="hidden" value="{{$total}}" name="total">
                                                  <input type="hidden" value="{{$customers->id}}" name="customer_id"><br>
                                                  <input type="submit" class="btn btn-primary btn-sm" style="color:white;margin-left: 80px" value="OUI">
                                                  <button type="button" class="btn btn-secondary btn-sm" data-dismiss="modal">NON</button>
                                              </form>
                                          </div>
                                      </div>
                                  </div>
                              </div>
                              <table class="table table-bordered">
                                  <thead>
                                  <th colspan="4">Liste des produits de <i style="color:green">{{$customers->name}}</i>  |  Total: {{number_format($total,0,',', '.')}} FCFA</th>
                                  </thead>
                                  <thead>
                                  <th>#</th>
                                  <th>Nom du produit</th>
                                  <th>Quantité</th>
                                  <th>Opérations</th>
                                  </thead>
                                  <tbody>
                                     @foreach($Commande as $i=>$c)
                                     <tr>
                                        <td>{{$i+1}}</td>
                                         <td>
                                             @php
                                                $Item=\App\Models\Item::find($c->item_id);
                                             @endphp
                                             @if($Item)
                                                 {{$Item->name}}
                                             @else
                                               Produit inconnu
                                             @endif
                                         </td>
                                         <td>{{$c->quantity}}</td>
                                         <td>
                                             <a href="{{route('AnnulerCommande',Crypt::encrypt($c->id))}}" class="btn btn-danger btn-sm" style="color:white">Annuler</a>
                                         </td>
                                     </tr>
                                     @endforeach
                                  </tbody>
                              </table>
                          </div>
                      </div>
                  </div>
                </div>
            </div>
        </div>

        <template id="command">
            <div class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
                <div style="display: inline-block;">
                    <label class="form-control-label" for="input-name">{{ __('Produit') }}</label><br>
                    <select name="item_id[]" class="form-control form-control-alternative{{ $errors->has('name') ? ' is-invalid' : '' }}"  id="">
                        @foreach($items as $item)
                            <option value="{{ $item->id }}">{{ $item->name }} -
                                @php
                                    $Categori=\App\Models\Category::find($item->category_id);
                                @endphp
                                @if($Categori)
                                    {{$Categori->name}}
                                @else
                                    Néant
                                @endif

                            </option>
                        @endforeach
                    </select>
                    @if ($errors->has('name'))
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $errors->first('name') }}</strong>
                        </span>
                    @endif
                </div>
                &nbsp; &nbsp;
                <div style="display: inline-block; vertical-align: top">
                    <label class="form-control-label" for="input-name">{{ __('Quantité') }}</label>
                    <input type="number" class="form-control form-control-alternative" name="quantity[]" value="1"/>
                </div>

            </div>
        </template>

        @include('layouts.footers.auth')
    </div>
@endsection

@push('js')
    <script>
        $('#btn-command').click(function(){
            $('#command-bloc').append($('#command').html())
        })
    </script>
@endpush