@extends('layouts.app', ['title' => __('User Management')])

@section('content')
    @include('layouts.headers.cards')

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="col-12">
                        @if (session('status'))
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                {{ session('status') }}
                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        @endif
                    </div>

                    <div style="margin-left: 25px">
                        <span style="display: inline-block">
                            <div style="background: lightpink; border: none; width: 20px; height: 10px"></div>
                        </span>
                        <span style="display: inline-block; font-size: 14px">
                             <div>Historique des ventes</div>
                        </span><br><br>
                    </div>

                    <div class="row" style="padding:10px">
                        <div class="col-md-4">
                            <div class="card">
                                <div class="card-header">Recherche par Produit</div>
                                <div class="card-body">
                                    <form method="post" action="{{route('HistoriqueProduit')}}">
                                        @csrf
                                        <label>Date Début</label>
                                        <input type="date" name="debut" class="form-control input-sm" value="{{  date('Y-m-d', strtotime('-'. $today_year  .' days')) }}" required><br>
                                        <label>Date Finale</label>
                                        <input type="date" name="finale" class="form-control input-sm" value="{{  $today_year }}" required><br>
                                        <div class="row">
                                            <div class="col-md-12">
                                                <label>Nom du produit</label>
                                                <select class="form-control input-sm" required name="idItem">
                                                    <option value="">Cliquez</option>
                                                    @php
                                                        $Item=\App\Models\Item::OrderBy('name','asc')->get();
                                                    @endphp
                                                    @foreach($Item as $i)
                                                        <option value="{{$i->id}}">{{$i->name}}</option>
                                                    @endforeach
                                                </select><br>
                                            </div>

                                        </div>
                                       <center><input type="submit" class="btn btn-primary btn-sm" value="Afficher">
                                        <!--<button type="button" class="btn btn-secondary btn-sm" data-dismiss="modal">Fermer</button>-->
                                       </center>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="card">
                                <div class="card-header">Recherche par catégorie de Produit</div>
                                <div class="card-body">
                                    <form method="post" action="{{route('HistoriqueCategorieProduit')}}">
                                        @csrf
                                        <label>Date Début</label>
                                        <input type="date" name="debut" class="form-control input-sm" value="{{  date('Y-m-d', strtotime('-'. $today_year  .' days')) }}" required><br>
                                        <label>Date Finale</label>
                                        <input type="date" name="finale" class="form-control input-sm" value="{{  $today_year }}" required><br>
                                        <div class="row">
                                            <div class="col-md-12">
                                                <label>Categorie du produit</label>
                                                <select class="form-control input-sm" required name="idCategorie">
                                                    <option value="">Cliquez</option>
                                                    @php
                                                        $Categorie=\App\Models\Category::OrderBy('name','asc')->get();
                                                    @endphp
                                                    @foreach($Categorie as $i)
                                                        <option value="{{$i->id}}">{{$i->name}}</option>
                                                    @endforeach
                                                </select><br>
                                            </div>

                                        </div>
                                        <center><input type="submit" class="btn btn-primary btn-sm" value="Afficher">
                                            <!--<button type="button" class="btn btn-secondary btn-sm" data-dismiss="modal">Fermer</button>-->
                                        </center>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="card">
                                <div class="card-header">Recherche par tranche de date</div>
                                <div class="card-body">
                                    <form method="post"  action="{{route('Historique')}}">
                                        @csrf
                                        <label>Date Début</label>
                                        <input type="date" name="debut" class="form-control input-sm" value="{{  date('Y-m-d', strtotime('-'. $today_year  .' days')) }}" required><br>
                                        <label>Date Finale</label>
                                        <input type="date" name="finale" class="form-control input-sm" value="{{  $today_year }}" required><br>
                                        <center><input type="submit" class="btn btn-primary btn-sm" value="Afficher">
                                            <!--<button type="button" class="btn btn-secondary btn-sm" data-dismiss="modal">Fermer</button>-->
                                        </center>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="card-footer py-4">
                        <nav class="d-flex justify-content-end" aria-label="...">
                            {{--                            {{ $users->links() }}--}}
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection