<?php $__env->startSection('content'); ?>
    <?php echo $__env->make('layouts.headers.cards', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-sales-center">
                            <div class="col-2">
                                <h3 class="mb-0"><?php echo e(__('Ventes')); ?></h3>
                            </div>
                            <div class="col-6">
                                <?php if($Success=Session::get('info')): ?>
                                    <div class="alert alert-success"><?php echo e($Success); ?></div>
                                <?php endif; ?>
                            </div>
                            <div class="col-4 text-right">
                                <a type="button" class="btn btn-success btn-sm" data-toggle="modal" data-target="#vente" style="color:white">Passer commande</a>
                            </div>
                        </div>
                    </div>

                    <?php if($errors->any()): ?>
                        <div class="msg">
                            <p>
                                <i class="fas fa-check"></i> <?php echo e($errors->first()); ?>

                            </p>
                        </div>
                    <?php endif; ?>

                    <div class="col-12">
                        <?php if(session('status')): ?>
                            <div class="alert alert-success alert-dismissible fade show" role="alert">
                                <?php echo e(session('status')); ?>

                                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                        <?php endif; ?>
                    </div>

                    <div class="table-responsive" style="padding:10px">
                        <table id="example1" class="table table-bordered table-striped">
                            <thead class="thead-light">
                            <tr>

                                <th scope="col"><?php echo e(__('Date d\'enregistrement')); ?></th>
                                <th scope="col"><?php echo e(__('Client')); ?></th>
                                <th scope="col"><?php echo e(__('Total')); ?></th>
                                <th scope="col"><?php echo e(__('Payée')); ?></th>
                                <th scope="col"><?php echo e(__('Détails')); ?></th>
                                <th scope="col"><?php echo e(__('Imprimer')); ?></th>
                                
                            </tr>
                            </thead>
                            <tbody>
                            <?php $__currentLoopData = $sales; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $sale): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                <tr>
                                    
                                    <td><?php echo e($sale->created_at->format('d-m-Y H:i:s')); ?></td>
                                    <td>
                                        <?php
                                            $Customer=\App\Models\Customer::find($sale->customer_id);
                                        ?>
                                        <?php if($Customer): ?>
                                            <?php echo e($Customer->name); ?>

                                        <?php else: ?>
                                            <?php echo e($sale->customer_id); ?>

                                        <?php endif; ?>
                                    </td>
                                    <td><?php echo e($sale->total); ?></td>
                                    <td>
                                        <label class="custom-toggle" style="color: green">
                                            <input type="checkbox" class="paid" data-id="<?php echo e($sale->id); ?>" <?php if($sale->paid): ?> checked <?php endif; ?>>
                                            <span class="custom-toggle-slider rounded-circle"></span>
                                        </label>
                                    </td>
                                    <td><a href="<?php echo e(route('Detailssale',$sale->id)); ?>"><i class="fas fa-info-circle"></i></a></td>
                                    <td><a href="<?php echo e(route('print',$sale->id)); ?>" target="_blank"><i class="fas fa-print"></i></a></td>
                                    
                                        
                                        
                                    
                                </tr>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer py-4">

                        <div class="modal fade" id="vente" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                            <div class="modal-dialog" role="document">
                                <div class="modal-content">
                                    <div class="modal-header" style="background: #1b4b72">
                                        <h5 class="modal-title" id="exampleModalLabel" style="color:white">Tableau de sélection du client</h5>
                                    </div>
                                    <div class="modal-body">
                                        <label>Nom du client</label><br>
                                        <?php
                                            $Client=\App\Models\Customer::OrderBy('name','asc')->get();
                                        ?>

                                                <table id="example2" class="table table-bordered table-striped">
                                                    <thead class="thead-light">
                                                    <tr>
                                                        
                                                        <th scope="col">#</th>
                                                        <th scope="col">Nom client</th>
                                                        
                                                    </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php $__currentLoopData = $Client; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $o=>$Client): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                          <tr>
                                                              <td><?php echo e($o+1); ?></td>
                                                              <td>
                                                                  <a class="btn btn-primary btn-sm" href="<?php echo e(route('createSale',Crypt::encrypt($Client->id))); ?>"><?php echo e($Client->name); ?></a>
                                                              </td>
                                                          </tr>
                                                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                                    </tbody>
                                                </table>


                                    </div>
                                </div>
                            </div>
                        </div>

                        <nav class="d-flex justify-content-end" aria-label="...">

                        </nav>
                    </div>
                </div>
            </div>
        </div>

        <?php echo $__env->make('layouts.footers.auth', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    </div>

    <?php $__env->startPush('js'); ?>
        <script>
            $('.paid').each(function(){
                if($(this).prop('checked')){
                    $(this).attr('disabled', 'disabled')
                }
            })
            $('.paid').change(function(){
                $.post('<?php echo e(route('togglePaid')); ?>', { _token : "<?php echo e(csrf_token()); ?>", id : $(this).attr('data-id') }, function(rsp){
                    console.log(rsp)
                })
                if($(this).prop('checked')){
                    $(this).attr('disabled', 'disabled')
                }
            })
        </script>
    <?php $__env->stopPush(); ?>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.app', ['title' => __('User Management')], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php /* C:\wamp64\www\stock\resources\views/sale/list.blade.php */ ?>