<?php $__env->startSection('content'); ?>
    <?php echo $__env->make('users.partials.header', ['title' => __('Vente')], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card bg-secondary shadow">
                    <div class="card-header bg-white border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0"><?php echo e(__('Imprimer une facture')); ?></h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="<?php echo e(route('sale')); ?>" class="btn btn-sm btn-primary"><?php echo e(__('Retourner à la liste')); ?></a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <form method="post" action="<?php echo e(route('printt',$sale->id)); ?>" autocomplete="off">
                            <?php echo csrf_field(); ?>

                            <h6 class="heading-small text-muted mb-4"><?php echo e(__('Informations sur la vente')); ?></h6>
                            <div class="pl-lg-4">

                                <div class="form-group<?php echo e($errors->has('name') ? ' has-danger' : ''); ?>">
                                    <label class="form-control-label" for="input-name"><?php echo e(__('Date')); ?></label><br>
                                    <span><?php echo e($sale->created_at->format('d-m-Y H:i:s')); ?></span>
                                </div>

                                <div class="form-group<?php echo e($errors->has('name') ? ' has-danger' : ''); ?>">
                                    <label class="form-control-label" for="input-name"><?php echo e(__('Client')); ?></label><br>
                                    <?php
                                        $Customer=\App\Models\Customer::find($sale->customer_id);
                                    ?>
                                    <?php if($Customer): ?>
                                        <span><?php echo e($Customer->name); ?></span>
                                    <?php else: ?>
                                        <span><?php echo e($sale->customer_id); ?></span>
                                    <?php endif; ?>

                                </div>

                                <div class="form-group<?php echo e($errors->has('name') ? ' has-danger' : ''); ?>">
                                    <table>
                                        <thead>
                                            <tr>
                                                <th style="width: 150px"><label for="" class="form-control-label">Produit</label></th>
                                                <th style="width: 150px"><label for="" class="form-control-label">Catégorie</label></th>
                                                <th style="width: 150px"><label for="" class="form-control-label">Quantité</label></th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                        <?php $__currentLoopData = $sale->commands; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $command): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                            <tr>
                                                <td><?php echo e($command->item->name); ?></td>
                                                <td><?php echo e($command->item->category->name); ?></td>
                                                <td><?php echo e($command->quantity); ?></td>
                                            </tr>
                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                        </tbody>
                                    </table>
                                </div>

                                <div class="form-group<?php echo e($errors->has('name') ? ' has-danger' : ''); ?>">
                                    <label class="form-control-label" for="input-name"><?php echo e(__('Total')); ?></label><br>
                                    <span style="font-size: 24px"><?php echo e($sale->total); ?></span>
                                </div>

                                <div class="text-center">
                                    <?php if($sale->paid): ?>
                                        <button type="submit" class="btn btn-success mt-4"><?php echo e(__('Imprimer')); ?></button>
                                    <?php else: ?>
                                        <input type="hidden" name="paid" value="1">
                                        <button type="submit" formtarget="_blank" class="btn btn-success mt-4"><?php echo e(__('Payer et Imprimer')); ?></button>
                                    <?php endif; ?>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <?php echo $__env->make('layouts.footers.auth', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    </div>
<?php $__env->stopSection(); ?>

<?php $__env->startPush('js'); ?>
    <script>
        $('#btn-command').click(function(){
            $('#command-bloc').append($('#command').html())
        })
    </script>
<?php $__env->stopPush(); ?>
<?php echo $__env->make('layouts.app', ['title' => __('User Management')], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php /* C:\wamp64\www\stock\resources\views/sale/show.blade.php */ ?>